明经CAD社区

 找回密码
 注册

扫一扫,访问微社区

QQ登录

只需一步,快速开始

查看: 105|回复: 0

[函数] LWPOLYLINE/POLYLINE多线段加删点继续画

[复制链接]
发表于 2020-10-17 22:14 | 显示全部楼层 |阅读模式
本帖最后由 wzg356 于 2020-10-22 21:21 编辑

;多线段加删点,LWPOLYLINE/POLYLINE二合一了
;en图元名,index顶点索引,pt点
;当pt为点表,相应点索引位置插入pt
;当pt点为nil,删除索引点(起点索引0)
(defun ContinuePoly (en index pt / obj pts nn)
        (setq obj (vlax-ename->vla-object en))
    (setq pts (vla-get-Coordinates obj))
    (setq pts (vlax-safearray->list (vlax-variant-value pts)))
    (if (= (cdr(assoc 0(entget en))) "LWPOLYLINE")
            (setq nn 2) (setq nn 3)
    )
    (if(= (type pt) 'list)
            (progn
                    (if(= nn 3)(setq pts (nth-list  0.0 (* nn index) pts)))
                        (setq pts (nth-list  (cadr pt) (* nn index) pts))
                    (setq pts (nth-list  (car pt) (* nn index) pts))
            )
            (repeat        nn(setq pts (nth-list nil (* nn index) pts)))
    )
        (vlax-put obj 'coordinates pts);设置坐标        
)
;;表n位插入v或删除n位元素
(defun nth-list (v n lst / i l1 l2)
        (setq l1 lst l2 (reverse lst))
        (if v(setq v (list v)i n)(setq i (1+ n)))
        (repeat i (setq l1(cdr l1)))
        (repeat (- (length lst) n) (setq l2 (cdr l2)))
        (append (reverse l2) (append v l1))
)


功能示例
(setq en (entsel "选择LWPOLYLINE,POLYLINE多线段")  e (car en))
(setq index(fix (vlax-curve-getparamatpoint e
                     (vlax-curve-getclosestpointto e (cadr en)))));所击子段
(setq numpt (if (vlax-curve-isClosed e)(fix (vlax-curve-getendParam e))
                         (1+ (fix (vlax-curve-getendParam e)))));顶点数量
(ContinuePoly e numpt (getpoint "\n请输入添加的点:"));末尾加点
(ContinuePoly e (1-numpt) nil);末尾删点                        
(ContinuePoly e (1+ index) (getpoint "\n请输入添加的点:"));所击子段加点
(ContinuePoly e 1 (getpoint "\n请输入添加的点:"));第1子段加点
(ContinuePoly e 0 nil);删除起点
(ContinuePoly e 0 (getpoint "\n请输入添加的点:"));起点加点

评分

参与人数 1明经币 +1 收起 理由
USER2128 + 1 赞一个!

查看全部评分

您需要登录后才可以回帖 登录 | 注册

本版积分规则

小黑屋|手机版|CAD论坛|CAD教程|CAD下载|联系我们|关于明经|明经通道 ( 粤ICP备05003914号  
©2000-2020 明经通道 版权所有 本站代码,在未取得本站及作者授权的情况下,不得用于商业用途

GMT+8, 2020-10-24 11:47 , Processed in 0.116491 second(s), 25 queries , Gzip On.

Powered by Discuz! X3.3

© 2001-2013 Comsenz Inc.

快速回复 返回顶部 返回列表